#include "gameobject.h"
#include "hovercraft.h"

class AiWaypoint : public GameObject {
	private:
		int number;
	public:
		AiWaypoint(Manager *m);
		virtual ~AiWaypoint() { }
		virtual void renderTo(const View &v);
		virtual void tick(Component quantum) { }
		virtual void setLocation(const Vect3d &where);
		static const char SAVE_CHAR = 'W';
		virtual char saveChar() { return SAVE_CHAR; }
		virtual void save(std::ostream &out) { out << number; }
		virtual void load(std::istream &in) { in >> number; }
		int getNumber() { return number; }
};

class AiController : public Controller {
	private:
		Component rudder;
		Component power;
		Manager *manager;
		HoverCraft *craft;
		int nextWaypoint;
		bool printStuff;
	public:
		AiController(Manager *m, HoverCraft *c);
		virtual void tick(Component quantum);
		// Returns something between -1 and 1
		virtual Component getRudder() { return rudder; }
		// Returns something between 0 and 1
		virtual Component getPower() { return power; }
		virtual void notifyCollision(GameObject *obj);
};


