#include "ui.h"
#include "language.h"

#include <allegro.h>
#include <stdlib.h>

#include <iostream>

// Using a C library!
#include <stdio.h>

using namespace std;
using namespace language;

static FONT * nicefont;

void uiInit()
{
	nicefont = font;
}

static void setcolours(DIALOG *dlg)
{
        for (int i=0; dlg[i].proc != NULL; i++) {
                dlg[i].fg = makecol(255,255,255); // makecol(255,255,255);
                dlg[i].bg = makecol(0,80,0);
                dlg[i].dp2 = nicefont;
        }
}

bool uiSelectLanguage()
{
	DIALOG dlgLang [] =
{
/* (dialog proc)	(x)	(y)	(w)	(h)	(fg),(bg)	(key)	(flags)	(d1)	(d2)	(dp),(dp2),(dp3) */
	{ d_clear_proc,	0,	0,	640,	480,	255,0,		0,	0,	0,	0,	NULL,NULL, NULL },
	{ d_box_proc,	0,	0,	640,	120,	255,0,		0,	0,	0,	0,	NULL,NULL, NULL },
	{ d_text_proc,	8,	8,	624,	104,	255,0,		0,	0,	0,	0,	(void *) "Language/ Langue etc" ,NULL, NULL },
	{ d_button_proc,8,	200,	400,	76,	255,0,	0,	D_EXIT, 0,	0,	
		(void *) languages[0].name ,NULL, NULL },
	{ d_button_proc,8,	280,	400,	76,	255,0,	0,	D_EXIT, 0,	1,	
		(void *) languages[1].name ,NULL, NULL },
	{ d_button_proc,8,	360,	400,	76,	255,0,	0,	D_EXIT, 0,	2,	
		(void *) languages[2].name ,NULL, NULL },
	{ d_button_proc,8,	450,	400,	25,	255,0,	0,	D_EXIT, 0,	-1,	
		(void *) "Quit" ,NULL, NULL },
	{ NULL, 0,    0,    0,    0,    0,    0,    0,    0,       0,      0,    NULL, NULL, NULL  }
		};
	
	setcolours(dlgLang);
	int res = do_dialog(dlgLang,3);
	if ((res >= 3) && (res <= 5)) {
		language::current = languages[res - 3].pack;
	} else {
		return false;
	}
	return true;
};


int uiMainMenu() // Returns level number, or 0 for quit
{
	DIALOG dlg [] =
{
/* (dialog proc)	(x)	(y)	(w)	(h)	(fg),(bg)	(key)	(flags)	(d1)	(d2)	(dp),(dp2),(dp3) */
	{ d_clear_proc,	0,	0,	640,	480,	255,0,		0,	0,	0,	0,	NULL,NULL, NULL },
	{ d_box_proc,	0,	0,	640,	120,	255,0,		0,	0,	0,	0,	NULL,NULL, NULL },
	{ d_text_proc,	8,	8,	624,	104,	255,0,		0,	0,	0,	0,	(void *) current->Track ,NULL, NULL },
	{ d_button_proc,8,	200,	400,	76,	255,0,	0,	D_EXIT, 0,	0,	
		(void *) current->Track1Msg ,NULL, NULL },
	{ d_button_proc,8,	280,	400,	76,	255,0,	0,	D_EXIT, 0,	1,	
		(void *) current->Track2Msg ,NULL, NULL },
	{ d_button_proc,8,	360,	400,	76,	255,0,	0,	D_EXIT, 0,	2,	
		(void *) current->Track3Msg ,NULL, NULL },
	{ d_button_proc,8,	450,	400,	25,	255,0,	0,	D_EXIT, 0,	-1,	
		(void *) "Quit" ,NULL, NULL },
	{ NULL, 0,    0,    0,    0,    0,    0,    0,    0,       0,      0,    NULL, NULL, NULL  }
	 };
	
	setcolours(dlg);
	clear_keybuf();
	int res = do_dialog(dlg,3);
	if ((res >= 3) && (res <= 5)) {
		return (res - 3) + 1;
	} else {
		return 0;
	}
}

